zenilib: zenilib/jni/external/freetype2/src/autofit/afhints.c File Reference

zenilib 0.5.3.0

- Main Page
- Modules
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Groups Pages
Functions
afhints.c File Reference
`#include "afhints.h"`
`#include "aferrors.h"`
`#include <FT_INTERNAL_CALC_H>`

Go to the source code of this file.

## Functions

| af_axis_hints_new_edge (AF_AxisHints axis, FT_Int fpos, AF_Direction dir, FT_Memory memory, AF_Edge *aedge)
| af_axis_hints_new_segment (AF_AxisHints axis, FT_Memory memory, AF_Segment *asegment)
| af_direction_compute (FT_Pos dx, FT_Pos dy)
| af_glyph_hints_align_edge_points (AF_GlyphHints hints, AF_Dimension dim)
| af_glyph_hints_align_strong_points (AF_GlyphHints hints, AF_Dimension dim)
| af_glyph_hints_align_weak_points (AF_GlyphHints hints, AF_Dimension dim)
| af_glyph_hints_done (AF_GlyphHints hints)
void | af_glyph_hints_dump_edges (AF_GlyphHints hints)
void | af_glyph_hints_dump_points (AF_GlyphHints hints)
void | af_glyph_hints_dump_segments (AF_GlyphHints hints)
FT_Error | af_glyph_hints_get_num_segments (AF_GlyphHints hints, FT_Int dimension, FT_Int *num_segments)
FT_Error | af_glyph_hints_get_segment_offset (AF_GlyphHints hints, FT_Int dimension, FT_Int idx, FT_Pos *offset)
| af_glyph_hints_init (AF_GlyphHints hints, FT_Memory memory)
| af_glyph_hints_reload (AF_GlyphHints hints, FT_Outline *outline)
| af_glyph_hints_rescale (AF_GlyphHints hints, AF_ScriptMetrics metrics)
| af_glyph_hints_save (AF_GlyphHints hints, FT_Outline *outline)
static void | af_iup_interp (AF_Point p1, AF_Point p2, AF_Point ref1, AF_Point ref2)
static void | af_iup_shift (AF_Point p1, AF_Point p2, AF_Point ref)

## Function Documentation

af_axis_hints_new_edge | ( | AF_AxisHints | axis,
|  | FT_Int | fpos,
|  | AF_Direction | dir,
|  | FT_Memory | memory,
|  | AF_Edge * | aedge
| ) |  |

Definition at line 69 of file afhints.c.

References AF_EdgeRec_::dir, error, AF_EdgeRec_::fpos, FT_INT_MAX, FT_RENEW_ARRAY, FT_ZERO, and NULL.

Referenced by af_latin2_hints_compute_edges(), and af_latin_hints_compute_edges().

af_axis_hints_new_segment | ( | AF_AxisHints | axis,
|  | FT_Memory | memory,
|  | AF_Segment * | asegment
| ) |  |

Definition at line 27 of file afhints.c.

References error, FT_INT_MAX, FT_RENEW_ARRAY, and NULL.

Referenced by af_latin2_hints_compute_segments(), and af_latin_hints_compute_segments().

af_direction_compute | ( | FT_Pos | dx,
|  | FT_Pos | dy
| ) |  |

Definition at line 459 of file afhints.c.

References AF_DIR_DOWN, AF_DIR_LEFT, AF_DIR_NONE, AF_DIR_RIGHT, AF_DIR_UP, FT_ABS, and FT_Pos.

Referenced by af_glyph_hints_reload().

af_glyph_hints_align_edge_points | ( | AF_GlyphHints | hints,
|  | AF_Dimension | dim
| ) |  |

Definition at line 814 of file afhints.c.

References AF_DIMENSION_HORZ, AF_FLAG_TOUCH_X, AF_FLAG_TOUCH_Y, AF_SegmentRec_::edge, AF_SegmentRec_::first, AF_PointRec_::flags, AF_SegmentRec_::last, AF_PointRec_::next, NULL, AF_AxisHintsRec_::num_segments, AF_EdgeRec_::pos, AF_AxisHintsRec_::segments, AF_PointRec_::x, and AF_PointRec_::y.

Referenced by af_latin2_hints_apply(), and af_latin_hints_apply().

af_glyph_hints_align_strong_points | ( | AF_GlyphHints | hints,
|  | AF_Dimension | dim
| ) |  |

Definition at line 889 of file afhints.c.

References AF_DIMENSION_HORZ, AF_DIMENSION_VERT, AF_FLAG_INFLECTION, AF_FLAG_TOUCH_X, AF_FLAG_TOUCH_Y, AF_FLAG_WEAK_INTERPOLATION, AF_AxisHintsRec_::edges, AF_PointRec_::flags, AF_EdgeRec_::fpos, FT_DivFix(), FT_MulFix(), FT_Pos, AF_PointRec_::fx, AF_PointRec_::fy, max, min, AF_AxisHintsRec_::num_edges, AF_EdgeRec_::opos, AF_PointRec_::ox, AF_PointRec_::oy, AF_EdgeRec_::pos, AF_EdgeRec_::scale, u, AF_PointRec_::x, and AF_PointRec_::y.

Referenced by af_latin2_hints_apply(), and af_latin_hints_apply().

af_glyph_hints_align_weak_points | ( | AF_GlyphHints | hints,
|  | AF_Dimension | dim
| ) |  |

Definition at line 1144 of file afhints.c.

References AF_DIMENSION_HORZ, AF_FLAG_TOUCH_X, AF_FLAG_TOUCH_Y, af_iup_interp(), af_iup_shift(), AF_PointRec_::flags, FT_ASSERT, AF_PointRec_::ox, AF_PointRec_::oy, AF_PointRec_::prev, AF_PointRec_::u, AF_PointRec_::v, AF_PointRec_::x, and AF_PointRec_::y.

Referenced by af_latin2_hints_apply(), and af_latin_hints_apply().

af_glyph_hints_done | ( | AF_GlyphHints | hints | ) |

Definition at line 517 of file afhints.c.

References AF_DIMENSION_MAX, AF_AxisHintsRec_::edges, FT_FREE, AF_AxisHintsRec_::max_edges, AF_AxisHintsRec_::max_segments, NULL, AF_AxisHintsRec_::num_edges, AF_AxisHintsRec_::num_segments, and AF_AxisHintsRec_::segments.

Referenced by af_latin2_metrics_init_widths(), af_latin_metrics_init_widths(), and af_loader_done().

void af_glyph_hints_dump_edges | ( | AF_GlyphHints | hints | ) |

Definition at line 444 of file afhints.c.

References FT_UNUSED.

void af_glyph_hints_dump_points | ( | AF_GlyphHints | hints | ) |

Definition at line 402 of file afhints.c.

References FT_UNUSED.

void af_glyph_hints_dump_segments | ( | AF_GlyphHints | hints | ) |

Definition at line 409 of file afhints.c.

References FT_UNUSED.

FT_Error af_glyph_hints_get_num_segments | ( | AF_GlyphHints | hints,
|  | FT_Int | dimension,
|  | FT_Int * | num_segments
| ) |  |

Definition at line 416 of file afhints.c.

References FT_UNUSED.

FT_Error af_glyph_hints_get_segment_offset | ( | AF_GlyphHints | hints,
|  | FT_Int | dimension,
|  | FT_Int | idx,
|  | FT_Pos * | offset
| ) |  |

Definition at line 429 of file afhints.c.

References FT_UNUSED.

af_glyph_hints_init | ( | AF_GlyphHints | hints,
|  | FT_Memory | memory
| ) |  |

Definition at line 508 of file afhints.c.

References FT_ZERO.

Referenced by af_latin2_metrics_init_widths(), af_latin_metrics_init_widths(), and af_loader_init().

af_glyph_hints_reload | ( | AF_GlyphHints | hints,
|  | FT_Outline * | outline
| ) |  |

Definition at line 571 of file afhints.c.

References AF_DIMENSION_HORZ, AF_DIMENSION_VERT, AF_DIR_DOWN, AF_DIR_LEFT, AF_DIR_NONE, AF_DIR_RIGHT, AF_DIR_UP, af_direction_compute(), AF_FLAG_CONIC, AF_FLAG_CUBIC, AF_FLAG_NONE, AF_FLAG_WEAK_INTERPOLATION, error, AF_PointRec_::flags, ft_corner_is_flat(), FT_CURVE_TAG, FT_CURVE_TAG_CONIC, FT_CURVE_TAG_CUBIC, FT_MulFix(), FT_ORIENTATION_POSTSCRIPT, FT_Outline_Get_Orientation(), FT_Pos, FT_RENEW_ARRAY, AF_PointRec_::fx, AF_PointRec_::fy, idx, if(), AF_PointRec_::in_dir, AF_PointRec_::next, NULL, AF_PointRec_::out_dir, AF_PointRec_::ox, AF_PointRec_::oy, AF_PointRec_::prev, vec, AF_PointRec_::x, and AF_PointRec_::y.

Referenced by af_latin2_hints_apply(), af_latin2_metrics_init_widths(), af_latin_hints_apply(), and af_latin_metrics_init_widths().

af_glyph_hints_rescale | ( | AF_GlyphHints | hints,
|  | AF_ScriptMetrics | metrics
| ) |  |

Definition at line 559 of file afhints.c.

Referenced by af_dummy_hints_init(), af_latin2_hints_init(), af_latin2_metrics_init_widths(), af_latin_hints_init(), and af_latin_metrics_init_widths().

af_glyph_hints_save | ( | AF_GlyphHints | hints,
|  | FT_Outline * | outline
| ) |  |

Definition at line 779 of file afhints.c.

References AF_FLAG_CONIC, AF_FLAG_CUBIC, AF_PointRec_::flags, FT_CURVE_TAG_CONIC, FT_CURVE_TAG_CUBIC, FT_CURVE_TAG_ON, vec, FT_Vector_::x, AF_PointRec_::x, and AF_PointRec_::y.

Referenced by af_latin2_hints_apply(), and af_latin_hints_apply().

static void af_iup_interp | ( | AF_Point | p1,
|  | AF_Point | p2,
|  | AF_Point | ref1,
|  | AF_Point | ref2
| ) |  |

static

Definition at line 1073 of file afhints.c.

References FT_MulDiv(), FT_Pos, u, AF_PointRec_::u, and AF_PointRec_::v.

Referenced by af_glyph_hints_align_weak_points().

static void af_iup_shift | ( | AF_Point | p1,
|  | AF_Point | p2,
|  | AF_Point | ref
| ) |  |

static

Definition at line 1046 of file afhints.c.

References for(), FT_Pos, AF_PointRec_::u, and AF_PointRec_::v.

Referenced by af_glyph_hints_align_weak_points().